<!--
GENERATED FILE - DO NOT EDIT
This file was generated by [MarkdownSnippets](https://github.com/SimonCropp/MarkdownSnippets).
Source File: /doc/mdsource/Tutorial.source.md
To change this file edit the source file and then execute ./run_markdown_templates.sh.
-->

<a id="top"></a>

# Test cases

<!-- toc -->
## Contents

  * [Hello Approval Tests](#hello-approval-tests)
    * [Writing the Test](#writing-the-test)
    * [Approving the Test](#approving-the-test)
  * [Dealing with test failures](#dealing-with-test-failures)
  * [Demo](#demo)<!-- endtoc -->

## anchor called top is removed

["Target 1"](/doc/DisposableObjects.md#top)

## other anchors are retained

[requirements for using Approval Tests With \[Boost\].UT](/doc/UsingUT.md#requirements).

## anchor with unusal characters in is updated correctly

[TCR](/doc/Glossary.md#test--commit--revert-tcr).

[Existing Project - with your main()](/doc/UsingCatch.md#existing-project---with-your-main).

## link to markdown file outside doc/ is unchanged

[How To Release](/build/HowToRelease.md#top)

### links to docs in various relative paths are correct

See [Target 1](/doc/subdir1/Doc1.md#target1).

See [Target 1](/doc/subdir/Doc1.md#target1).

See [Target 1](/doc/Doc1.md#target1).

## Multiple links on one line

See [Target 1](/doc/Doc1.md#target1) join1 [Target 2](/doc/Doc2.md#target3) join2 [Target 3](/doc/Doc3.md#target3).

### Links to directories

[the build directory](/build/)

[doc](/doc/).

[/ApprovalTests/integrations/](/ApprovalTests/integrations/)

## Links to source files

[tests/GoogleTest_Tests/main.cpp](/tests/GoogleTest_Tests/main.cpp)

## Links to images

Tutorial ![Intro Graphic](/doc/images/ApprovalTests.cpp.IntroGraphic.gif?raw=true)

Tutorial ![New Failure](/doc/images/tutorial/01_new_failure.png?raw=true)

## Non-HTML links - should be unchanged

[Llewellyn](mailto:llewellyn.falco@gmail.com)

## Do not change specific links that are in code blocks

```md
* [this link will work everywhere](/doc/Reporters.md#top)
```

Not this:

```md
* [this link is wrong](doc/Reporters.md#top)
```

And not this:

```md
* [this link is wrong](Reporters.md#top)
```

# Links whose hyperlinked text is in fixed-width font

From Namers.md:

The interface for this is [`ApprovalNamer`](https://github.com/approvals/ApprovalTests.cpp/blob/master/ApprovalTests/core/ApprovalNamer.h).

From CMakeIntegration.md:

[`ExternalProject` module](https://cmake.org/cmake/help/latest/module/ExternalProject.html)

[`add_subdirectory()`](https://cmake.org/cmake/help/latest/command/add_subdirectory.html).

From UsingUT.md

[`std::source_location`](https://en.cppreference.com/w/cpp/utility/source_location)

From Setup.md

[`tests/NewTest.cpp`](https://github.com/approvals/ApprovalTests.cpp.StarterProject/blob/master/tests/NewTest.cpp)

Multiple on one line

[`ExternalProject` module](https://cmake.org/cmake/help/latest/module/ExternalProject.html) and `this should still be fixed width` and [`add_subdirectory()`](https://cmake.org/cmake/help/latest/command/add_subdirectory.html).

## Test code snippet - linking to lines in a file

<!-- snippet: verify_exception_message_example -->
<a id='snippet-verify_exception_message_example'/></a>
```cpp
Approvals::verifyExceptionMessage([]() { /* your code goes here */ });
```
<sup><a href='/tests/DocTest_Tests/ApprovalsTests.cpp#L105-L107' title='File snippet `verify_exception_message_example` was extracted from'>snippet source</a> | <a href='#snippet-verify_exception_message_example' title='Navigate to start of snippet `verify_exception_message_example`'>anchor</a></sup>
<!-- endsnippet -->

## Test code snippet - linking to a whole file

<!-- snippet: VectorTests.VerifyAllStartingPoint.approved.txt -->
<a id='snippet-VectorTests.VerifyAllStartingPoint.approved.txt'/></a>
```txt
TITLE


input.value1 => placeholder
input.value2 => placeholder

```
<sup><a href='/tests/DocTest_Tests/approval_tests/VectorTests.VerifyAllStartingPoint.approved.txt#L1-L6' title='File snippet `VectorTests.VerifyAllStartingPoint.approved.txt` was extracted from'>snippet source</a> | <a href='#snippet-VectorTests.VerifyAllStartingPoint.approved.txt' title='Navigate to start of snippet `VectorTests.VerifyAllStartingPoint.approved.txt`'>anchor</a></sup>
<!-- endsnippet -->

## Test changes made to satisfy Pygments

### Convert h to cpp

```h
class Wibble
{
};
```

### Remove txt

```txt
I am some text
```

## A wide table

| Framework    |  Min C++  | Ease of setup      | IDE Support           | Build time  |
| ------------ | :-------: | ------------------ | --------------------- | ----------- |
| Catch2       |   C++11   | Very easy [1], [2] | Widely supported      | Not bad [3] |
| doctest      |   C++11   | Very easy [1]      | Unknown               | Fast        |
| Google Test  |   C++11   | Difficult          | Very widely supported | Fast        |
| Boost.Test   |   C++11   | Difficult          | Unknown               | Fast        |
| \[Boost\].UT | C++20 [4] | Very easy [1]      | Unknown               | Fast        |

1. Released as a single header file
2. See the [Starter Project](https://github.com/approvals/ApprovalTests.Cpp.StarterProject)
3. Catch2 has [options to speed up its builds](https://github.com/catchorg/Catch2/blob/master/docs/slow-compiles.md#top)
4. \[Boost\].UT works with C++17, but the ApprovalTests interface to that library depends on [std::source_location](https://en.cppreference.com/w/cpp/utility/source_location), which is a C++ 20 feature. 


---

[Back to User Guide](/doc/README.md#top)
